# avm/make/generated/genhdr-stub.make  *** auto-generated by kernel/gu-wrapper *** --
#
# This auto-generated Makefile will be called for each AVM Linux subproject
# that wants to generate header files before the Linux build starts.  It also
# handles the generation of compatibility header files.
#
# It uses the subprojects' avm/make/genhdr.make Makefile and evaluates
# $(avm-autogen-headers-y); e.g.:
#
#	avm-autogen-headers-y += include/generated/uapi/avm/event/event.h
#
#	define filechk_avm_event.h
#		$(srctree)/$(src)/generate-avm_event.h
#	endef
#
#	$(obj)/include/generated/uapi/avm/event/event.h: /dev/null FORCE
#		$(call filechk,avm_event.h)
# .

# Avoid accidental calls
.PHONY: /nonexistent/default
/nonexistent/default:
	@echo "Please specify a make target"

# Read auto.conf if it exists, otherwise ignore
-include include/config/auto.conf
include scripts/Kbuild.include

# Pre-3.19 Linux hdr-inst is only defined in Makefile and Makefile.headersinst.
# Define it here, if missing
hdr-inst ?= -rR -f $(srctree)/scripts/Makefile.headersinst obj

# If present allow subproject to specify generated headers and rules to
# generate them. All headers must live in include/generated/
avm-autogen-headers-y =
-include $(srctree)/$(src)/avm/make/genhdr.make

avm-compat-headers-file := $(srctree)/$(src)/avm/conf/compat.headers
# avm-compat-headers-file is optional
ifneq (,$(wildcard $(avm-compat-headers-file)))
# Collect compatibility header files to generate in include/generated/
avm-compat-headers := $(shell awk '/^[^\#]/{ if (match($$1, "^uapi/")) { print "include/generated/" $$1; } else { print "include/generated/lisi/" $$1; }}' $(avm-compat-headers-file))
else
avm-compat-headers :=
endif

# For some rules it is crucial that filename paths are _not_ prefixed with
# './', which occurs during in-tree builds.  $(non_local_srctree_slash) does
# the correct filtering: "" (empty) or "$(srctree)/" (w/ trailing slash).
non_local_srctree_slash = $(if $(filter-out .,$(srctree)),$(srctree)/)

avm-compat-headers-uapi := $(filter include/generated/uapi/%,$(avm-compat-headers))
avm-compat-headers-lisi:= $(filter include/generated/lisi/%,$(avm-compat-headers))
# Collect UAPI folders that need to be installed
avm-uapi-header-dirs := $(dir $(wildcard $(non_local_srctree_slash)$(src)/include/uapi/avm/*/))
__avm_uapi_install_targets := $(addprefix __uapi_install/,$(avm-uapi-header-dirs))

gen-headers: $(avm-autogen-headers-y) $(avm-compat-headers)
	@:

# Generate compatibility header file with the definition provided
#
# The default part will be kernel only and simply forward from the specified
# header file to the intended location.  This will also incorporate the header
# file search path, so cross-project compatibility header files are possible
# but frowned upon.
#
# For header files put into uapi/, this also creates a forwarding but drops the
# uapi/ path component on install. (Done via unifdef which undefines __KERNEL__)
#
define gen_compat_header
	$(Q)set -e;\
	$(kecho) "  COMPAT  $@";\
	mkdir -p $(dir $@);\
	awk '$$1 == "$1" {\
		print "#ifdef __KERNEL__";\
		print "#include <" $$2 ">";\
		if (match($$1, "^uapi/")) {\
			sub(/^uapi\//, "", $$1);\
			sub(/^uapi\//, "", $$2);\
			print "#else";\
			print "#include <" $$2 ">";\
		};\
		print "#endif";\
	}' < $< > $@;
endef

# To avoid expensive reevaluation of all compatibility header files, the
# dependencies are explicitly specified.  The generated headers only depend on
# this makefile and the header file definition of the subproject.
$(avm-compat-headers): $(non_local_srctree_slash)avm/make/generated/genhdr-stub.make
$(avm-compat-headers-uapi): include/generated/uapi/%: $(avm-compat-headers-file)
	$(call gen_compat_header,$(@:include/generated/%=%))
$(avm-compat-headers-lisi): include/generated/lisi/%: $(avm-compat-headers-file)
	$(call gen_compat_header,$(@:include/generated/lisi/%=%))

install-headers: $(__avm_uapi_install_targets)
	@:

# To install UAPI header files, the Linux mechanism is reused.  This mechanism
# expects a Kbuild in every UAPI source directory to specify the installed
# header files.  To simplify the usage for subproject authors, this file is
# temporarily created when needed and deleted afterwards.
#
# A present Kbuild file will not be overridden and allows the user to override
# the behaviour.  However note that this Kbuild then also needs to take care of
# the compatibility header files.
#
$(__avm_uapi_install_targets): __uapi_install/%/: % %/Kbuild FORCE
	$(MAKE) $(hdr-inst)=$(<:$(srctree)/%=%) \
		dst=$(<:$(srctree)/$(src)/%=%) \
		gen=$(<:$(srctree)/$(src)/include/%=include/generated/%)

$(srctree)/$(src)/include/uapi/avm/%/Kbuild:
	$(Q)set -e; \
	mkdir -p $(dir $@);			\
	trap "rm -f $@" EXIT;			\
	$(kecho) '  GEN     $@';		\
	{ \
	  echo 'header-y += $(notdir $(wildcard $(dir $@)/*.h))'; \
	  for hdr in \
	    $(filter $(@:$(non_local_srctree_slash)$(src)/%/Kbuild=%)/%,$(avm-autogen-headers-y:include/generated/%=include/%)); \
	  do echo "genhdr-y += $${hdr##*/}"; done \
	} >$@; \
	trap - EXIT

.INTERMEDIATE: $(addsuffix Kbuild,$(avm-uapi-header-dirs))

.PHONY: FORCE gen-headers install-headers
FORCE:

# vim: set ft=make:
